LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;

entity part4 is
	port
	(
			CLOCK_50	 : in std_logic;
		   KEY : in STD_LOGIC_VECTOR(0 downto 0);	
			SW  : in STD_LOGIC_VECTOR(9 downto 0);	
			HEX0 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX1 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX2 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX3 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX4 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX5 : OUT STD_LOGIC_VECTOR(0 TO 6)		
	);
end;


architecture behav of part4 is
   signal AddressW, AddressR : std_logic_vector(4 downto 0);
	signal DataIn, DataOut : std_logic_vector(3 downto 0);
   signal Clock, Write, resetn, pulse1s: std_logic; 	
begin

  resetn <= KEY(0);
  DataIn <= SW(3 downto 0);
  AddressW <= SW(8 downto 4);
  Write <= SW(9) and pulse1s;
  
Count0:
   entity work.counter(behav)
	generic map(26, 50_000_000)
	port map(clock=> CLOCK_50, reset_n => resetn, enable=>'1', Q => open, rollover => pulse1s);
  
Count1:
   entity work.counter(behav)
	generic map(5, 32)
	port map(clock=> CLOCK_50, reset_n => resetn, enable=>pulse1s, Q => AddressR, rollover => open);
  
  
UUT : entity work.ram32x4 
   port map ( clock => CLOCK_50, data => DataIn, rdaddress => AddressR,  
	          wraddress => AddressW,  wren => Write, q => DataOut );

				
H0: 
   entity work.DisplayDigit PORT MAP (DataOut, HEX0);	
H1: 
   entity work.DisplayDigit PORT MAP (DataIn, HEX1);		
H2: 
   entity work.DisplayDigit PORT MAP (AddressR(3 downto 0), HEX2);	
H3: 
   entity work.DisplayDigit PORT MAP (("000"&AddressR(4)), HEX3);		
H4: 
   entity work.DisplayDigit PORT MAP (AddressW(3 downto 0), HEX4);		
H5: 
   entity work.DisplayDigit PORT MAP (("000"&AddressW(4)), HEX5);	
	

end architecture;
	
	
	
